/* $Header: /usr2/brugere/jbln/uc133/src/RCS/findfile.c,v 1.2 1995/03/06 23:18:47 jbln Exp jbln $ */

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#include "uc.h"
#include "input.h"
#include "keys.h"
#include "lists.h"


typedef struct
{
   char *path;
   char *name;
   int isfile;
} FFDATA;

static FFDATA *ffdata = NULL;
static int ffnum = 0;
static int ffmore;

static char ffmask[100] = {"*"};
static char fftopdir[UCPATHSIZE] = {"/usr2/brugere"};

static ff_init();
static ff_addfile();
static ff_view();
static ff_draw();
static ff_update();
static ff_showall();
static ff_showone();
static ff_showbutt();

#define FFMAXNUM 200
#define FFLISTSIZE 5
#define FFLISTLEN 50

#define xs FFLISTLEN+6
#define ys FFLISTSIZE+9
#define yp 6-FFLISTSIZE/2
#define xp 37-FFLISTLEN/2

static char *ff_buttons[3] = {"NEW", "GOTO", "CANCEL"};
#define FF_NEW 0
#define FF_GOTO 1
#define FF_CANCEL 2

/************************************************************
   FILEFIND
************************************************************/

do_rec_find(level, visited)
int level;
NAMELIST *visited;
{
   DIR *dirp;
   char tmp[UCPATHSIZE];
   struct dirent *dp;
   struct stat sb;
   int n;
   int found=0, first=1;

   getcwd(tmp, UCPATHSIZE);

   if (lst_exists(visited, tmp))
      return(0);
   visited = lst_add(visited, tmp);

   if (level == 1)
   {
      mvprintw(22,10, "%-60.60s", tmp);
      refresh();
   }

   for (n=0 ; n<2 ; n++)
   {
      if ( (dirp=opendir(".")) != NULL)
      {
         while ( (dp=readdir(dirp)) != (struct dirent *)NULL )
         {
            stat(dp->d_name, &sb);
	    if (n==1)
	    { 
               if ( (sb.st_mode & FMODE_SPEC) == FMODE_DIR  &&
                    strcmp(dp->d_name, ".") != 0  &&
                    strcmp(dp->d_name, "..") != 0)
               {
	          if (chdir(dp->d_name)==0)
	             found |= do_rec_find(level+1, visited);
                  chdir(tmp);
               }
	    }
            else
	    {
               if (fname_match(dp->d_name, ffmask)  &&
                   (sb.st_mode & FMODE_SPEC) != FMODE_DIR)
               {
		  if (first)
		     ff_addfile(tmp, dp->d_name, 0);
		  ff_addfile(tmp, dp->d_name, 1);
		  found = 1;
                  first = 0;
               }
	    }
	 }
         closedir(dirp);
      }
   }

   visited = lst_del(visited, tmp);

   return(found);
}


ff_clear()
{
   int n;

   for (n=0 ; n<ffnum ; n++)
   {
      free(ffdata[n].path);
      free(ffdata[n].name);
   }

   if (ffnum > 0)
      free(ffdata);

   ffdata = NULL;
   ffnum = 0;
}


ff_addfile(path, name, isfile)
char *path;
char *name;
int isfile;
{
   if (ffnum >= FFMAXNUM)
   {
      ffmore = 1;
      return(0);
   }

   if (ffnum ==0)
      ffdata = (FFDATA *)malloc(sizeof(FFDATA));
   else
      ffdata = (FFDATA *)realloc(ffdata, sizeof(FFDATA)*(ffnum+1));

   ffdata[ffnum].path = strdup(path);
   ffdata[ffnum].name = strdup(name);
   ffdata[ffnum].isfile = isfile;
   ffnum++;
   
   return(1);
}


do_findfile(pos)
{
   int p=0, o=0;
   int op= -1, oo= -1;
   int more=1, c;
   int butt=0;
   int retval = FF_CANCEL;

   ff_draw();

   while (more)
   {
      if ((op!=p  ||  oo!=o)  &&  ffnum > 0)
      {
	 if (oo != o)
	 {
	    ff_showall(o,p);
	 }
	 else
	 if (op != -1)
	    ff_showone(op, op+oo, 0);

	 ff_showone(p,p+o,1);
	 op = p;
	 oo = o;
      }
      else
      if (ffnum == 0)
      {
         move (yp+1, xp+3);
         printw("[No files]");
      }

      refresh();
      c = ti_getch();

      if (c == terminal.up)
      {
	 p--;
      }
      else
      if (c == terminal.down)
      {
	 p++;
      }
      else
      if (c == terminal.left)
      {
         ff_showbutt(butt,0);
         butt = (butt+2) % 3;
         ff_showbutt(butt,1);
      }
      else
      if (c == terminal.right  ||  c == key_tab)
      {
         ff_showbutt(butt,0);
	 butt = (butt+1) % 3;
         ff_showbutt(butt,1);
      }
      else
      if (c == terminal.enter)
      {
         if (butt == FF_GOTO  &&  ffnum>0)
         {
            more = 0;
            retval = FF_GOTO;
         }
         else
         if (butt == FF_NEW)
         {
            if (inp_input(xp+9,yp+FFLISTSIZE+2, ffmask, 30,100,INPKEEP) != INPESC)
               if (inp_input(xp+11,yp+FFLISTSIZE+4, fftopdir, 30,100,INPKEEP) != INPESC)
               {
                  ff_start_find();
                   o = p = 0;
                   oo = op = -1;
               }
            ff_showbutt(butt,0);
            butt = FF_GOTO;
            ff_showbutt(butt,1);
         }
         else
         if (butt == FF_CANCEL)
            more = 0;
      }
      else
      switch(c)
      {
	 case 'q'	:
	 case 'Q'	:
	 case key_cc	:
	 case key_cd	: more = 0;
			  break;
      }

      if (p >= FFLISTSIZE)
      {
         p = FFLISTSIZE-1;
         if (o+p < ffnum-1)
            o++;
      }

      if (p < 0)
      {
         p = 0;
         if (o > 0)
            o--;
      }

   }  /* while more */

   if (retval != FF_CANCEL)
      strcpy(uc[pos].path, ffdata[o+p].path);

   chdir(uc[pos].path);
   shortpath(pos);
   if (retval != FF_CANCEL)
   {
      if (ffdata[o+p].isfile)
         ff_update(pos, ffdata[o+p].name);
      else
         ff_update(pos, "..");
   }
   else
      update2_bscreens(N(pos));

   return(retval);
}

static ff_update(pos, fname)
int pos;
char *fname;
{
   int fpos; 

   find_files(pos);
   fpos = filename2pos(fname, pos);
   if (fpos > uc[pos].size)
      uc[pos].offset = fpos;
   else
      uc[pos].offset = 0;
   uc[pos].pos = fpos - uc[pos].offset;
   uc[pos].oldpos = -1;
   uc[pos].oldoffset = uc[pos].offset;

   update_screen(pos);
   update_screen(N(pos));
}


ff_start_find()
{     
   int found=0;
   NAMELIST *visited = NULL;

   if (chdir(fftopdir) != 0)
   {
      prompt("ERROR : Could not change to start directory.","");
      ti_getch();
   }
   else
   {
      prompt("Scanning: ","");
      ff_clear();
      ffmore = 0;
      found = do_rec_find(0, visited);
      if (!found)
         ff_showall(0,0);
      if (ffmore)
         mvprintw(yp+FFLISTSIZE+1, xp+3, "[more]");
      else
         mvprintw(yp+FFLISTSIZE+1, xp+3, "------");
   }

   prompt("","");
   return(found);
}


static ff_draw()
{   
   int n;

   uc_clear(yp,xp-1,ys,xs+2);
   show_box(xp,yp, xp+xs,yp+ys-1);
   prompt("","");
   ff_showbutt(0,1);
   ff_showbutt(1,0);
   ff_showbutt(2,0);

   mvprintw(yp+FFLISTSIZE+2, xp+3, "MASK: %s", ffmask);
   mvprintw(yp+FFLISTSIZE+4, xp+3, "TOPDIR: %s", fftopdir);

   for (n=0 ; n<FFLISTLEN+5 ; n++)
      mvaddch(yp+FFLISTSIZE+1, xp+n+1, '-');
}


static ff_showall(o,p)
int o,p;
{
   int n;

   for (n=0 ; n<FFLISTSIZE ; n++)
   {
      if (n+o < ffnum)
	 ff_showone(n, n+o, 0);
      else
         mvprintw(yp+1+n, xp+3, "%*s", FFLISTLEN-10, " ");
   }
}


static ff_showone(y,n,domark)
int y,n;
int domark;
{
   move (yp+1+y, xp+3);
   if (domark)
      attrset(A_REVERSE);

   if (ffdata[n].isfile)
      printw("   %-*.*s", FFLISTLEN-3, FFLISTLEN-3, ffdata[n].name);
   else
      printw("%-*.*s", FFLISTLEN, FFLISTLEN, ffdata[n].path);

   if (domark)
      attroff(A_REVERSE);
}


static ff_showbutt(butt, mark)
int butt,mark;
{
   if (mark)
      attrset(A_REVERSE);

   move(yp+FFLISTSIZE+6,xp+3+butt*10);
   printw("[%s]", ff_buttons[butt]);

   if (mark)
      attroff(A_REVERSE);
}


